<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VehicleAvailCoreTypeTotalCharge StructType
 * @package Dg
 * @subpackage Structs
 */
class DgVehicleAvailCoreTypeTotalCharge extends AbstractStructBase
{
    /**
     * The RateTotalAmount
     * @var float
     */
    public $RateTotalAmount;
    /**
     * The EstimatedTotalAmount
     * @var float
     */
    public $EstimatedTotalAmount;
    /**
     * The RateConvertInd
     * @var bool
     */
    public $RateConvertInd;
    /**
     * Constructor method for VehicleAvailCoreTypeTotalCharge
     * @uses DgVehicleAvailCoreTypeTotalCharge::setRateTotalAmount()
     * @uses DgVehicleAvailCoreTypeTotalCharge::setEstimatedTotalAmount()
     * @uses DgVehicleAvailCoreTypeTotalCharge::setRateConvertInd()
     * @param float $rateTotalAmount
     * @param float $estimatedTotalAmount
     * @param bool $rateConvertInd
     */
    public function __construct($rateTotalAmount = null, $estimatedTotalAmount = null, $rateConvertInd = null)
    {
        $this
            ->setRateTotalAmount($rateTotalAmount)
            ->setEstimatedTotalAmount($estimatedTotalAmount)
            ->setRateConvertInd($rateConvertInd);
    }
    /**
     * Get RateTotalAmount value
     * @return float|null
     */
    public function getRateTotalAmount()
    {
        return $this->RateTotalAmount;
    }
    /**
     * Set RateTotalAmount value
     * @param float $rateTotalAmount
     * @return \dgsoft\StructType\DgVehicleAvailCoreTypeTotalCharge
     */
    public function setRateTotalAmount($rateTotalAmount = null)
    {
        $this->RateTotalAmount = $rateTotalAmount;
        return $this;
    }
    /**
     * Get EstimatedTotalAmount value
     * @return float|null
     */
    public function getEstimatedTotalAmount()
    {
        return $this->EstimatedTotalAmount;
    }
    /**
     * Set EstimatedTotalAmount value
     * @param float $estimatedTotalAmount
     * @return \dgsoft\StructType\DgVehicleAvailCoreTypeTotalCharge
     */
    public function setEstimatedTotalAmount($estimatedTotalAmount = null)
    {
        $this->EstimatedTotalAmount = $estimatedTotalAmount;
        return $this;
    }
    /**
     * Get RateConvertInd value
     * @return bool|null
     */
    public function getRateConvertInd()
    {
        return $this->RateConvertInd;
    }
    /**
     * Set RateConvertInd value
     * @param bool $rateConvertInd
     * @return \dgsoft\StructType\DgVehicleAvailCoreTypeTotalCharge
     */
    public function setRateConvertInd($rateConvertInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($rateConvertInd) && !is_bool($rateConvertInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($rateConvertInd)), __LINE__);
        }
        $this->RateConvertInd = $rateConvertInd;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgVehicleAvailCoreTypeTotalCharge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
